<?php
App::uses('EvShopAppController', 'EvShop.Controller');

class BrandsController extends EvShopAppController {

	protected function _adminFilterFields() {
		$fields = parent::_adminFilterFields();

		unset(
			$fields['Brand.id'],
			$fields['Brand.created'],
			$fields['Brand.modified']
		);

		return $fields;
	}

	/**
	 * redefine to allow the index / view page through the auth component!
	 */
	public function beforeFilter() {
		if (! Configure::read('EvShop.showBrands')) {
			throw new NotFoundException();
		}

		parent::beforeFilter();

		$this->Auth->allow(array('index', 'view'));
	}

	/**
	 * brands index page
	 * list all brands out
	 *
	 */
	public function index() {
		$this->view = 'EvShop./Fallbacks/Brands/index';
		$pageId = Configure::read('EvShop.pageIds.brand');

		// check if we have a specific content page set
		// if so - set the template
		if (! empty($pageId)) {
			$pageData = $this->assignPage($pageId);

			if (! empty($pageData)) {
				$this->view = $this->Tpl->getTemplate($pageData, 'Page');
			}
		}

		$this->set(
			'listing',
			$this->Brands->listing()
		);
	}

	/**
	 * brand view details page
	 *
	 * @param 	int 	Brand ID
	 */
	public function view($id) {
		$this->view = 'EvShop./Fallbacks/Brands/view';

		$data = $this->Brand->readForView($id);
		if (empty($data)) {
			throw new NotFoundException();
		}

		$this->set('data', $data);
		$this->Meta->set($data);

		if (! empty($data)) {
			$this->view = $this->Tpl->getTemplate($data);
		}

		$this->set(
			'productListing',
			$this->Products->listingByBrand($id)
		);
	}
}
